#include "mcc_generated_files/mcc.h"

#define TIME_OFF -1     //^C}[gpȂꍇ
#define TIME_UP 0       //^CAbv
#define TIM_RX_WAIT 20   //200ms
#define TIM_TX_WAIT 300  //300ms
#define TIM_BTN_WAIT 5
#define TIM_INIT_WAIT 300
#define RING_SZ 64
#define TX_SZ 10
#define HEADER 'L'
#define OFFSET_SZ 5
#define CR 0x0D
#define LF 0x0A

const char select[] = "2";	//[hIFprocessor
const char node1[] = "a 1";	//m[hʁFCoordinaor(e@)
const char node2[] = "a 2";	//m[hʁFEndDevice(q@)
const char panid[] = "e 12AB";	//m[hPAMAhXF0x4553
const char ownid1[] = "f 0000";	//m[h̃AhXF0x0000(e@)
const char ownid2[] = "f 0001";	//m[h̃AhXF0x0001(q@)
const char dstid1[] = "g 0001";	//M̃AhXF0x0001(e@)
const char dstid2[] = "g 0000";	//M̃AhXF0x0000(q@)
const char form[] = "A 2";	//
const char savepara[] = "w";	//FlashROMɕۑ
const char start[] = "z";	//RtBO[VIAIy[VɑJ

typedef struct{
    uint8_t wp;
    uint8_t rp;
    uint8_t buf[RING_SZ];
}RING_MNG;

typedef struct{
    uint8_t cnt;
    uint8_t max;
    uint8_t data[TX_SZ];
}TX_MNG;

typedef enum{	//Ӱ
    COM_RX_WAIT = 0,
    COM_RCVDATA,
    COM_TX,
    COM_MAX
}COM_MODE_NO;

typedef enum{	//[h
    INIT_WAIT = 0,
    INIT_SEL,
    INIT_SEL_WAIT,        
	INIT_NODE,
	INIT_NODE_WAIT,
	INIT_PANID,
	INIT_PANID_WAIT,
	INIT_OWNID,
	INIT_OWNID_WAIT,
	INIT_DSTID,
	INIT_DSTID_WAIT,
    INIT_FORM,
    INIT_FORM_WAIT,
	//INIT_SAVE,
	//INIT_SAVE_WAIT,
	INIT_START,
	INIT_START_WAIT,
	INIT_END,
	INIT_ERR,
	INIT_MAX,
}INIT_MODE;

/* ϐ` */
int16_t  timRxWait = TIME_OFF;
int16_t  timTxWait = TIME_OFF;
int16_t  timbtn = TIME_OFF;
int16_t timRecive = TIME_OFF;
int16_t timInitWait = TIME_OFF;
RING_MNG    picRcv;
TX_MNG  Txdata;
COM_MODE_NO ComMode;
uint8_t Rcvdata[RING_SZ];
bool    loraInit= true;
bool    selParent = false; //e@Ȃtrue
bool    pushbtn = false;
INIT_MODE	initmode;		//LORA[h

/* ֐ߐ錾 */
void eUsartmain(bool init);
void mainApp(void);
void mainTimer(void); //ϰ0荞݂ł̏
void ReadPointerAdd(void);
uint8_t CalcSum(uint8_t *buf, uint8_t sz );
bool RcvChk(void);
bool TxDataSet(bool boo, uint8_t cmd);
bool IntTxDataSet( uint8_t *dat, uint8_t sz );

/* Main application */
void main(void)
{
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(mainTimer);
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    
    //ɎqƐe؂肯镔
    if( IO_RB0_GetValue() == 0 ){ //e@LOWƂ
        selParent = true;
    }
            
    timInitWait = TIM_INIT_WAIT;
    
    while (1)
    {
        eUsartmain(loraInit);
        mainApp();
    }
}
/* ^C}Ǘ֐ */
void mainTimer(void){
 
    if( timRxWait > TIME_UP ){
        --timRxWait; //^C}XV
    }
    
    if( timTxWait > TIME_UP ){
        --timTxWait; //^C}XV
    }
    
    if( timRecive > TIME_UP ){
        --timRecive;
    }
    
    if( timbtn > TIME_UP ){
        --timbtn;
    }
    
    if( timInitWait > TIME_UP ){
        --timInitWait;
    }
}
/* C֐ */
void mainApp(void){
    
    while(EUSART_is_rx_ready())
    {
        picRcv.buf[picRcv.wp] = EUSART_Read(); //f[^[h
        if( ++picRcv.wp >= sizeof(picRcv.buf)){ //ɕۊǂʒuXV
            picRcv.wp = 0;
        }
    }
    
    if( timRecive == TIME_UP ){
        timRecive = TIME_OFF;
        IO_RB6_SetLow();
    }
    
    if( selParent == false ){
        if( timbtn == TIME_UP && pushbtn ){
            if( TxDataSet(selParent, 0) ){
                pushbtn = false;
            }
        }

        if( IO_RB4_GetValue() == 0 ){
            if( timbtn == TIME_OFF ){
                timbtn = TIM_BTN_WAIT;
                pushbtn = true;
            }
        }
        else{
            timbtn = TIME_OFF;
            pushbtn = false;
        }
    }
    
    if(loraInit){
        switch(initmode){
            case INIT_WAIT:
                if(timInitWait == TIME_UP ){
                    timInitWait = TIME_OFF;
                    initmode = INIT_SEL;
                }
                break;
            case INIT_SEL:
				if( IntTxDataSet((uint8_t*)&select,1)){
					initmode = INIT_SEL_WAIT;
				}            
                break;
            case INIT_NODE:
                if(selParent){
                    if( IntTxDataSet((uint8_t*)&node1,3)){
                        initmode = INIT_NODE_WAIT;
                    }                   
                }
                else{
                    if( IntTxDataSet((uint8_t*)&node2,3)){
                        initmode = INIT_NODE_WAIT;
                    }                     
                }
                break;
            case INIT_PANID:
                if( IntTxDataSet((uint8_t*)&panid,6)){
                    initmode = INIT_PANID_WAIT;
                }                
                break;
            case INIT_OWNID:
                if(selParent){
                    if( IntTxDataSet((uint8_t*)&ownid1,6)){
                        initmode = INIT_OWNID_WAIT;
                    }                   
                }
                else{
                    if( IntTxDataSet((uint8_t*)&ownid2,6)){
                        initmode = INIT_OWNID_WAIT;
                    }                     
                }
                break;
            case INIT_DSTID:
                if(selParent){
                    if( IntTxDataSet((uint8_t*)&dstid1,6)){
                        initmode = INIT_DSTID_WAIT;
                    }                   
                }
                else{
                    if( IntTxDataSet((uint8_t*)&dstid2,6)){
                        initmode = INIT_DSTID_WAIT;
                    }                     
                }
                break;
            case INIT_FORM:    
                if( IntTxDataSet((uint8_t*)&form,3)){
                    initmode = INIT_FORM_WAIT;
                }                 
                break;
            case INIT_START:
                if( IntTxDataSet((uint8_t*)&start,3)){
                    initmode = INIT_START_WAIT;
                }                   
                break;                
            case INIT_END:
                loraInit = false;
                break; 
        }
    }
}
/* VAʐMC */
void eUsartmain(bool init){
    int16_t rxsz;
    uint8_t datsz;
    uint8_t allsz;
    uint8_t rp = picRcv.rp;  
    uint8_t i;
    uint8_t	sumchk;
    uint8_t dat[2];
    
    if(init == false ){
        if( timRxWait == TIME_UP){ //M^CAEg
            timRxWait = TIME_OFF;
            ReadPointerAdd(); 
            ComMode = COM_RX_WAIT;
        }
    }
    
    switch( ComMode ){
        case COM_RX_WAIT:
            rxsz = picRcv.wp - picRcv.rp; //Mf[^̎Zo
    
            if( rxsz < 0 ){
                rxsz = rxsz + RING_SZ;
            }
            
            if( rxsz == 0 ){
				timRxWait = TIME_OFF;
			}
            else{
                if( timRxWait == TIME_OFF ){
                    timRxWait = TIM_RX_WAIT; //M^CAEgZbg
                }
                
                if(init){
                    if( timRxWait == TIME_UP ){ //f[^lĂ邩
                        timRxWait = TIME_OFF;
                        
                        for(i=0; i < sizeof(Rcvdata); i++){
                            Rcvdata[i] = 0; //obt@̃NA
                        }

                        for( i=0; i < rxsz; i++ ){
                            Rcvdata[i] = picRcv.buf[picRcv.rp]; //ꎞۊǂf[^ڂ
                            ReadPointerAdd(); //ǂݍ݈ʒu̍XV
                        }
                        ComMode = COM_RCVDATA; //[hJ
                    }
                }
                else{
                    if( rxsz >= 2 ){ //f[^lĂ邩
                        for( i = 0; i < 2; i++){//f[^TCYZô߉
                            dat[i] = picRcv.buf[ rp ];
                            if(++rp >= sizeof(picRcv.buf) ) rp = 0;
                        }
                            
                        if( dat[1] == HEADER){
                            if( dat[0] > sizeof(picRcv.buf) ){
                                allsz = sizeof(picRcv.buf);
                            }
                            else{
                                datsz = dat[0] - 2; //headersumO
                                allsz = dat[0] + 1; //f[^܂
                            }
                            
                            if( rxsz >= allsz){ //m肵TCYȏォ
                                timRxWait = TIME_OFF;

                                for(i=0; i < sizeof(Rcvdata); i++){
                                    Rcvdata[i] = 0; //obt@̃NA
                                }

                                for( i=0; i < allsz; i++ ){
                                    Rcvdata[i] = picRcv.buf[picRcv.rp]; //ꎞۊǂf[^ڂ
                                    ReadPointerAdd(); //ǂݍ݈ʒu̍XV
                                }

                                sumchk = CalcSum(&Rcvdata[2], datsz); //`FbNŤvZ
                                if( sumchk == Rcvdata[allsz-1]){ //`FbNT̊mF
                                    ComMode = COM_RCVDATA; //[hJ
                                }
                            }    
                        }
                        else{
                            ReadPointerAdd(); 
                        }
                    }                     
                }
            }
            break;
        case COM_RCVDATA: 
            if( RcvChk() ){
                ComMode = COM_TX;
                timTxWait = TIM_TX_WAIT;
            }
            else{
                ComMode = COM_RX_WAIT;
            }
            break;
        case COM_TX:
            if(EUSART_is_tx_ready()){ //MrW[łȂ
                if ( Txdata.cnt < Txdata.max ){
                    EUSART_Write(Txdata.data[Txdata.cnt]); //f[^𑗐M
                    ++Txdata.cnt; //Mf[^JEgXV
                }
                else{ //Sf[^̑M
                    timTxWait = TIME_OFF;
                    ComMode = COM_RX_WAIT; //M҂ɑJ
                }
            }  
                
            if( timTxWait == TIME_UP ){ //M^CAEg
                timTxWait = TIME_OFF;
                ComMode = COM_RX_WAIT; //M҂ɑJ
            }
            break;        
    }
}
/* ǂݍ݈ʒu̍XV */
void ReadPointerAdd(void){
    
    if(++picRcv.rp >= sizeof(picRcv.buf) ){
        picRcv.rp = 0;
    }
}
/* `FbNŤvZ */
uint8_t CalcSum(uint8_t *buf, uint8_t sz ){
    uint8_t ret = 0;

    for(uint8_t i=0; i < sz; i++ ){
        ret += *buf;
        buf++; 
    }
    return ret;
}
/* d̏ */
bool RcvChk(void){
    bool ret = false;
    uint32_t cmd;
    int16_t tim;
    
    if(loraInit){
        if( Rcvdata[0] == 'O' && Rcvdata[1] == 'K'){
            ++initmode;
        }
    }
    else{
        if(selParent){ //qȅƕԐM
            cmd = Rcvdata[2];
                   
            switch(cmd){
                case 0:
                    tim = ( Rcvdata[4] << 8 ) + Rcvdata[5];
                    timRecive = tim;
                    IO_RB6_SetHigh();
                    //TxDataSet(true,0);
                    //ret = true;
                    break;
                //case 1:
                    //p^[ǉĂ
                //    break;
            } 
        }
        else{ //eq
            //e̕ԐMŏꍇ͒ǉ
        }
    }
     
    return ret;
}
/* Mf[^ */
bool TxDataSet(bool boo, uint8_t cmd){
    bool ret = false;
    uint8_t i=0;
    
    if( ComMode == COM_RX_WAIT ){
        Txdata.cnt = 0;
        
        Txdata.data[i++] = 6;//HEADER;
        Txdata.data[i++] = HEADER;//5; //cmd+4byte
        
        if( boo ){ //eq
            Txdata.data[i++] = cmd | 0x80;
            Txdata.data[i++] = 0x30;
            Txdata.data[i++] = 0x30;
            Txdata.data[i++] = 0x30;      
        }
        else{ //qe
            Txdata.data[i++] = cmd;
            Txdata.data[i++] = 0;
            Txdata.data[i++] = 1;
            Txdata.data[i++] = 0xF4;       
        }

        Txdata.data[i++] = CalcSum(&Txdata.data[2], 4);
        Txdata.max = i;
        ComMode = COM_TX;
        timTxWait = TIM_TX_WAIT;
        ret = true;
    }
    return ret;
}
/* Mf[^ */
bool IntTxDataSet( uint8_t *dat, uint8_t sz ){
    bool ret = false;
    uint8_t i;
     
    if( ComMode == COM_RX_WAIT ){
        Txdata.cnt = 0;
        for( i = 0; i < sz; i++){
            Txdata.data[i] = *dat;
            ++dat;
        }

        Txdata.data[i++] = CR;
        Txdata.data[i++] = LF;
        Txdata.max = i;
        ComMode = COM_TX;
        timTxWait = TIM_TX_WAIT;
        ret = true;
    }
    return ret;
}
/* End of File */